{**********************************************************}
{                                                          }
{          BLUE CODE for Delphi                            }
{                                                          }
{          Copyright (c) 1996-97 BlueCodeX                 }
{                                                          }
{**********************************************************}

unit DualMain;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, DualDlg, PropInfo, PrpCtrls,
  RtReg, RtAddReg, RtStdReg;

type
  TForm1 = class(TForm)
    DualListDialog1: TDualListDialog;
    Label1: TLabel;
    Label2: TLabel;
    Bevel1: TBevel;
    PropertyGrid1: TPropertyGrid;
    RegStdPropertyEditors1: TRegStdPropertyEditors;
    RegAddPropertyEditors1: TRegAddPropertyEditors;
    Bevel2: TBevel;
    Panel1: TPanel;
    Memo1: TMemo;
    procedure DualListDialog1Change(Sender: TObject; Action: TDualAction);
    procedure DualListDialog1Changing(Sender: TObject;
      Action: TDualAction);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormDestroy(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
uses
  TypInfo, BlcUtils, EventInf, DemoHelp, DemConst;

var
  { Liste mit den Eigenschaften von TDualListDialog, die von TCustomPanel
    geerbt wurden. }
  InheritedProperties: TStringFilter;

procedure TForm1.DualListDialog1Change(Sender: TObject;
  Action: TDualAction);
begin
  ShowEventInfo(Sender, 'DualListDialog1Change', SOnChangeDDlgParam,
    SOnChangeDDlgInfo, SPerPropertyGrid);
end;

procedure TForm1.DualListDialog1Changing(Sender: TObject;
  Action: TDualAction);
begin
  ShowEventInfo(Sender, 'DualListDialog1Changing', SOnChangingDDlgParam,
    SOnChangingDDlgInfo, SPerPropertyGrid);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  InitHelp;
  with PropertyGrid1 do
  begin
    Form := self;
    ComponentList := MakeComponentList([DualListDialog1]);
  end;
  InheritedProperties := TStringFilter.Create;
  AssignStrings(InheritedProperties.Items, MakeStrings(['A*', 'Bor*', 'Co*',
   'F*', 'H*', 'Left', 'Na*', 'P*', 'Top', 'Show*', 'W*', '*.*'], True), True);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  InheritedProperties.Free;
  FreeHelp;
end;

{ Hilfe zu allen im PropertyGrid gezeigten Eigenschaften von TDualListDialog }
procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  I: Integer;
begin
  if (Key = VK_F1) and (Shift = []) and (ActiveControl.Owner = PropertyGrid1) then
    with PropertyGrid1, PropertyList do
    begin
      I := SelProperty;
      { Falls eine Untereigenschaft von Font.Style oder ListFont.Style selektiert
        ist, so wird die Eigenschaft Style an ShowDemoHelp bergeben}
      if PropKind[I] = tkSet then I := PropNames.IndexOf('Style');
      if  I <> -1 then
      begin
        ShowDemoHelp(PropName[I], TDualListDialog,
           not InheritedProperties.IsValidStr(FullPropName[I]),
           PropKind[I] = tkMethod, (PropKind[I] = tkMethod) or
           (PropName[I] = 'Sorted'));
        Key := 0;
      end;
    end;
end;

end.



